/*
@@@BUILDINFO@@@ EMailer.jsx 2.4.0  05-Oct-2012
*/

///////////////////////////////////////////////////////////////////////////////
// // Some globals at the top for easy editing
try { 

var emailer = new Object;
emailer.showAlerts = true; // use this for debug purposes and not for normal alerts
emailer.JPEGQuality = 8;
emailer.logFile;
emailer.extraDebug = false;
emailer.smartSharpenDesc = undefined;
emailer.smartSharpenWasCanceled = false;

///////////////////////////////////////////////////////////////////////////////
// Function: runHelp
// Usage: Called from the panel so we can run the help web page
// Input: <nothing>
// Return: XML describing the full path to the watermark file
///////////////////////////////////////////////////////////////////////////////
emailer.runHelp = function () {
	var s = "";
	try {
		s = "<HTML><HEAD><META HTTP-EQUIV=REFRESH CONTENT=";
		s += '"0; URL=http://av.adobe.com/russellbrown/emailer_help.mov ">';
		s += "</HEAD><BODY>";
		s += "<!---CENTER><BR><BR><b><i><span style='font-family:Arial'>";
		s += "redirecting to documentation...</span></i></b></center--->";
		s += "</BODY></HTML>";

		var helpFile = new File( Folder.temp.toString() + '/EMailer.html' );
		if (helpFile.open('w')) {
			helpFile.write( s );
			helpFile.close();
			helpFile.execute();
			s = emailer.stringToXML("Success");
		}
	}
	catch(e) { 
		if (emailer.showAlerts) 
			alert(e + " : " + e.line); 
	}
	return s;
}


///////////////////////////////////////////////////////////////////////////////
// Function: toggleExtraDebug
// Usage: Called from the panel so we can toggle the debug flag
// Input: <nothing>
// Return: <nothing>
///////////////////////////////////////////////////////////////////////////////
emailer.toggleExtraDebug = function () {
	emailer.extraDebug = emailer.extraDebug ? false : true;
}


emailer.runProcess = function( inParamsAsSource ) {
	try {
		emailer.cleanTempFolder( emailer.getTempScriptFolder() );
		emailer.clearLog();
		var s = "";
		
		emailer.smartSharpenDesc = undefined;
		
		emailer.smartSharpenWasCanceled = false;
		
		var params = emailer.paramsToParams( inParamsAsSource )

		emailer.writeToLog(params.toSource());

		switch (params.ddMailProgram) {
			case "Microsoft Entourage": params.ddMailProgram = "Microsoft Entourage"; break;
			case "Microsoft Outlook": params.ddMailProgram = "Microsoft Outlook"; break;
			case "Apple Mail": params.ddMailProgram = "Mail"; break;
			case "Outlook": params.ddMailProgram = "Outlook"; break;
			case "Outlook Express": params.ddMailProgram = "OutlookExpress"; break;
			case "Thunderbird": params.ddMailProgram = "Thunderbird"; break;
			default: params.ddMailProgram = "Outlook";
		}

		params.filesToAttach = new  Array();
		
		if ( documents.length == 0 ) {
			s = emailer.stringToXML("No open documents");
			alert("No open documents")
			return s;
		}
		
		if ( params.cbSizeToFit ) {
			var unitWidth = emailer.stringToUnitValue( params.etSizeToFitW );
			var unitHeight = emailer.stringToUnitValue( params.etSizeToFitH );
		}

		var tempFolder = emailer.getTempScriptFolder();
		
		if (params.cbSendAll) {
			var currentActive = app.activeDocument;
			for ( var i = 0; i < documents.length; i++ ) {
				app.activeDocument = app.documents[i];
				var doc = app.activeDocument.duplicate();
				var splitUp = new FileFolderSplitter( app.documents[i].fullName.fsName );
				var uniqueFileName = CreateUniqueFileName( tempFolder + "/", splitUp.name, ".jpg" ); // was  + splitUp.extension );
				doc.flatten();
				if ( params.cbSizeToFit ) {
					var w = emailer.unitsToPixels( unitWidth.value, unitWidth.type, doc.resolution, doc.width.as("px") );
					var h = emailer.unitsToPixels( unitHeight.value, unitHeight.type, doc.resolution, doc.height.as("px") );
					emailer.fitImage( w, h, "Bicubic" );
				}
				if (params.cbConvert) {
					emailer.convertTosRGBProfile();
				}
				if ( params.cbSmartSharpen ) {
					emailer.webSharpen( doc, params.cbShowSmartSharpen );
				}
				emailer.mySave( uniqueFileName );
				doc.close( SaveOptions.DONOTSAVECHANGES );
				params.filesToAttach.push( new File( uniqueFileName ) );
			}
			app.activeDocument = currentActive;
		} else {
			var splitUp = new FileFolderSplitter( activeDocument.fullName.fsName );
			var doc = app.activeDocument.duplicate();
			var uniqueFileName = CreateUniqueFileName( tempFolder + "/", splitUp.name, ".jpg" ); // was  + splitUp.extension );
			doc.flatten();
			if ( params.cbSizeToFit ) {
				var w = emailer.unitsToPixels( unitWidth.value, unitWidth.type, doc.resolution, doc.width.as("px") );
				var h = emailer.unitsToPixels( unitHeight.value, unitHeight.type, doc.resolution, doc.height.as("px") );
				emailer.fitImage( w, h, "Bicubic" );
			}
			if (params.cbConvert) {
				emailer.convertTosRGBProfile();
			}
			if ( params.cbSmartSharpen ) {
				emailer.webSharpen( doc, params.cbShowSmartSharpen );
			}
			emailer.mySave( uniqueFileName );
			doc.close( SaveOptions.DONOTSAVECHANGES );
			params.filesToAttach.push( new File( uniqueFileName ) );
		}
	
		emailer.fitOnScreen();
	
		emailer.sendMailWithApplication( params );
		
		s = emailer.stringToXML("EMail message sent successfully!");
	}
	
	catch(e) { 
		if (emailer.showAlerts) alert(e + " : " + e.line); 
		s = emailer.errorToXML(e);
	}
	
	return s;
	
}


emailer.paramsToParams = function( inParamsAsSource ) {
	var params = eval( decodeURIComponent( unescape( inParamsAsSource ) ) );
	params.etSizeToFitW = decodeURIComponent( unescape( params.etSizeToFitW ) );
	params.etSizeToFitH = decodeURIComponent( unescape( params.etSizeToFitH ) );
	return params;
}


emailer.cleanTempFolder = function ( f ) {
	var a = f.getFiles();
	for (var i = 0; i < a.length; i++) {
		a[i].remove();
	}
}

// WARNING: inString must be valid XML
// TODO: should I do that now, what about on the swf end ?
emailer.stringToXML = function (inString) {
    var s = '<object>';
    s += emailer.propertyToXML(0, "error");
    s += emailer.propertyToXML(inString, "message");
    s += '</object>';
    return s;
}

// inError is a JSX error from a catch(e) 
emailer.errorToXML = function(inError) {
    var s = '<object>';
    s += emailer.propertyToXML(inError.number, "error");
    s += emailer.propertyToXML(inError.message, "message");
    s += emailer.propertyToXML(inError.line, "line");
    s += emailer.propertyToXML(inError.fileName, "fileName");
    s += '</object>';
    return s;
}

// convert a local type to something that can go back to SWF
emailer.propertyToXML = function(inProperty, inID) {
    var t = typeof inProperty;
    var s = '<property id="' + inID + '">';
    switch (t) {
        case "number":
            s += '<number>' + inProperty.toString() + '</number>';
            break;
        case "boolean":
            s += '<' + inProperty.toString() + '/>';
            break;
        case "string":
            s += '<string>' + inProperty.toString() + '</string>';
            break;
        // TODO figure this out
        case "object":
            //s += '<object>';
			//for (var i in inProperty) {
			//	s += emailer.propertyToXML(inProperty[i], i.toString());
			//}
			//s += '</object>';
            break;
        case "undefined":
            s += '<string>undefined</string>';
            break;
        default:
            if (emailer.showAlerts) alert('unknown type not supported: ' + t);
            break;
    }
    s += '</property>';
    return s;
}

emailer.getTempScriptFolder = function()
{
	var tempScriptFolder = Folder.temp;
	tempScriptFolder = new Folder( tempScriptFolder.toString() + "/Adobe EMailer" );
	tempScriptFolder.create();
	return tempScriptFolder;
}

emailer.getLogFile = function() {
	if( typeof emailer.logFile == "undefined" ) 	{
		emailer.logFile =  new File( emailer.getTempScriptFolder() + "/Adobe Emailer Log.txt" );
	}
	return emailer.logFile;
}

emailer.clearLog = function() {
	emailer.getLogFile();
	if( emailer.logFile && emailer.logFile.exists ) {
		emailer.logFile.remove();
	}
}

emailer.showLog = function () {
	emailer.getLogFile();
	if( emailer.logFile && emailer.logFile.exists ) {
		emailer.logFile.execute();
	} else {
		alert('No log file.')
	}
}

emailer.writeToLog = function( info )
{
	emailer.getLogFile();
			
	emailer.logFile.open("a");
	emailer.logFile.writeln( info );
	emailer.logFile.close();
}

emailer.sendMailWithApplication = function( messageConfig )
{
	if( Folder.fs != "Macintosh" && Folder.fs != "Windows") {
		throw new Error("Sending E-mail with a client is not yet supported on " + Folder.fs );
	}
	
	if( Folder.fs == "Macintosh") {
		this.sendMailViaAppleScript(messageConfig);
	} else {
		this.sendMailViaWindowsScriptHost(messageConfig);
	}
}

emailer.sendMailViaWindowsScriptHost = function(messageConfig)
{
	var myInstructions = File(emailer.getTempScriptFolder() + "/Adobe EMailer.vbs");
	if (myInstructions.open("w")) {
		myInstructions.write('WScript.echo "Creating ');
		myInstructions.write(messageConfig.ddMailProgram);
		myInstructions.writeln(' message from Adobe Photoshop ..."');
		myInstructions.writeln('On Error Resume Next');
		if (messageConfig.ddMailProgram == "Thunderbird") {
			myInstructions.writeln('Dim wsh');
			myInstructions.writeln('Set wsh = CreateObject( "WScript.Shell" )');
			myInstructions.writeln('keyPathToExe = "HKEY_CLASSES_ROOT\\Thunderbird.Url.mailto\\shell\\open\\command\\"');
			myInstructions.writeln('regKeyValue = wsh.RegRead ( keyPathToExe )');
			myInstructions.writeln('regArray = Split ( regKeyValue, "-" )');
			myInstructions.writeln('pathToExe = regArray ( 0 )');
			myInstructions.writeln('WScript.Echo pathToExe');
			myInstructions.write('fullString = pathToExe & " -compose attachment=');
			myInstructions.write("'");
			for (var i = 0; i < messageConfig.filesToAttach.length; i++) {
				myInstructions.write( File( messageConfig.filesToAttach[i] ).fsName );
				if ((i+1) != messageConfig.filesToAttach.length) {
					myInstructions.write(',');
				}
			}
			myInstructions.write("'");
			myInstructions.writeln('"');
			myInstructions.writeln('WScript.Echo fullString');
			myInstructions.writeln('Set oExec = wsh.Exec(fullString)');
			myInstructions.writeln('');
			myInstructions.writeln('REM Do While oExec.Status = 0');
			myInstructions.writeln('REM      WScript.Sleep 100');
			myInstructions.writeln('REM Loop');
			myInstructions.writeln('');
			myInstructions.writeln('WScript.Echo oExec.Status');
		} else {
			myInstructions.writeln('Dim outlook');
			myInstructions.write('Set outlook = CreateObject("');
			myInstructions.write(messageConfig.ddMailProgram);
			myInstructions.writeln('.Application")');
			myInstructions.writeln('ReportError("After outlook create")');
			myInstructions.writeln('Set newMail = outlook.CreateItem(0)');
			myInstructions.writeln('ReportError("After newMail create")');
			for (var i = 0; i < messageConfig.filesToAttach.length; i++) {
				myInstructions.write('newMail.Attachments.Add "');
				myInstructions.writeln( File( messageConfig.filesToAttach[i] ).fsName + '"');
				myInstructions.writeln('ReportError("After attachments add")');
			}
			myInstructions.writeln('newMail.display');
			myInstructions.writeln('ReportError("After display")');
			myInstructions.writeln('Sub ReportError(lineNumber)');
			myInstructions.writeln(' If Err.Number > 0 Then');
			myInstructions.writeln('  WScript.echo lineNumber & " " & Err.Number & " " & Err.Source');
			myInstructions.writeln('  Err.Clear');
			myInstructions.writeln(' End If');
			myInstructions.writeln('End Sub');
		}
		myInstructions.close();
		
		var myRunner = File(emailer.getTempScriptFolder() + "/Adobe EMailer.bat");
		if (myRunner.open("w")) {
            if (emailer.extraDebug) {
                myRunner.write('cmd /k ');
             }
			myRunner.writeln('cscript "' + emailer.getTempScriptFolder().fsName + '\\Adobe EMailer.vbs"');
			myRunner.close();
			myRunner.execute();
		} else {
			alert("Could not execute instructions")
		}
	} else {
		alert("Could not create instructions");
	}
}

emailer.sendMailViaAppleScript = function(messageConfig)
{
	var myInstructions = new File(emailer.getTempScriptFolder() + "/Adobe Emailer.txt");
	if (myInstructions.open("w")) {
		myInstructions.writeln(messageConfig.ddMailProgram);
		for (var i = 0; i < messageConfig.filesToAttach.length; i++) {
			myInstructions.writeln(File(messageConfig.filesToAttach[i]).fsName);
		}
		myInstructions.close();
		var myRunner = new File(app.path.toString() + "/Plug-ins/Panels/Adobe EMailer/Adobe Emailer.app");
		if (myRunner.exists) {
			myRunner.execute();
		}
	}
} 

///////////////////////////////////////////////////////////////////////////////
// Function: FitImage
// Usage: copied and modified from FitImage.jsx
// Input: width height and interpolation method
// Return:
///////////////////////////////////////////////////////////////////////////////
emailer.fitImage = function ( inWidth, inHeight, inInterpolation ) {
	
	if ( inWidth == undefined || inHeight == undefined ) {
		if (emailer.showAlerts) alert( "Width and Height must be defined to use FitImage function!" );
		return;
	}

	var oldPref = app.preferences.rulerUnits;	
	var docWidth;
	var docHeight;
	var docRatio;
	var newWidth;
	var newHeight;
	var resolution = app.activeDocument.resolution;
	
    app.preferences.rulerUnits = Units.PIXELS; // save old preferences

	// original width, height
	docWidth = (1.0 * app.activeDocument.width * resolution) / 72.0; // decimal inches assuming 72 dpi (used in docRatio)
	docHeight = (1.0 * app.activeDocument.height * resolution) / 72.0; // ditto
	
	if (docWidth < 1.0 || docHeight < 1.0)
		return true; // error
	
	if (inWidth < 1 || inHeight < 1)
		return true; // error
	
	docRatio = docWidth / docHeight; // decimal ratio of original width/height
	
	// NOTE - ccox - 17 Aug 2004 - I added the rounding by 0.5
	// this should solve reported cases of fit image being off by 1 (always under)
	// NOTE - elr - 3 May 2006 - keep original aspect ratio
	// NOTE - mshaw- 16 Sept 2007 commenting out lines and adding lines to match fixed FitImage script
	newWidth = inWidth;
	/*newHeight = ((1.0 * inWidth) / docRatio) + 0.5; // decimal calc
	newHeight = 1 * newHeight; // make integer*/
	newHeight = ((1.0 * inWidth) / docRatio); // decimal calc

	
	if (newHeight > inHeight) {
		/*newWidth = 0.5 + docRatio * inHeight; // decimal calc
		newWidth = 1 * newWidth; // make integer*/
		newWidth = docRatio * inHeight; // decimal calc
		newHeight = inHeight;
	}
	
	if ( typeof( inInterpolation ) == "string" ) {
		var interpoArray = { NearestNeighbor:ResampleMethod.NEARESTNEIGHBOR, Bilinear:ResampleMethod.BILINEAR, Bicubic:ResampleMethod.BICUBIC, BicubicSmoother:ResampleMethod.BICUBICSMOOTHER, BicubicSharper:ResampleMethod.BICUBICSHARPER };
		var lookupstring = inInterpolation.replace(" ", "");
		inInterpolation = interpoArray[ lookupstring ];
	} else {
		alert("Bad interpolation : " + typeof( inInterpolation ));
	}

    // resize the image using a good conversion method while keeping the pixel resolution
    // and the aspect ratio the same
    app.activeDocument.resizeImage(newWidth, newHeight, resolution, inInterpolation);
    app.preferences.rulerUnits = oldPref; // restore old prefs

	return false; // no error
}

///////////////////////////////////////////////////////////////////////////////
// Function: CreateUniqueFileName
// Usage:
// Input:
// Return:
///////////////////////////////////////////////////////////////////////////////
function CreateUniqueFileName( inFolder, inFileName, inExtension ) {
	var originalFileName = inFileName;
	inFileName = inFileName.replace(/[:\/\\*\?\"\<\>\|\&]/g, "_");  // '/\:*?"<>|' -> '_'
	// if (inFileName != originalFileName) alert(inFileName +":"+ originalFileName);
	var uniqueFileName = inFolder + inFileName + inExtension;
	var fileNumber = 1;
	while ( File( uniqueFileName ).exists ) {
		uniqueFileName = inFolder + inFileName + "_" + fileNumber + inExtension;
		fileNumber++;
	}
	return uniqueFileName;
}

///////////////////////////////////////////////////////////////////////////////
// Function: FileFolderSplitter
// Usage: Given a full path to a file or a file with an extension or no full
//        path and no extension return the .folder, .name and .extension
// Input: string or File, folder seperator is "/" or "\\"
// Return: object containing .folder, .name and .extension
///////////////////////////////////////////////////////////////////////////////
function FileFolderSplitter( inFullPath ) {
	this.name = inFullPath;
	this.folder = "";
	this.extension = "";
	if ( inFullPath instanceof File || inFullPath instanceof Folder ) {
		this.name = inFullPath.name;
		this.folder = inFullPath.parent.toString();
	} else {
		if ( typeof this.name == 'string' ) {
			var lastSlash = this.name.lastIndexOf( "/" );
			if ( lastSlash == -1 ) {
				lastSlash = this.name.lastIndexOf( "\\" );
			}
			if ( lastSlash != -1 ) {
				this.folder = this.name.substr( 0, lastSlash );
				this.name = this.name.substr( lastSlash + 1, this.name.length );
			}
		}
	}
	// this.name could have the extension but the folder is ready to go
	// so in theory i don't have to worry about . (dots) in folder names
	if ( typeof this.name == 'string' ) {
		var lastDot = this.name.lastIndexOf( "." );
		if ( lastDot == -1 ) {
			lastDot = this.name.length;
		}
		this.extension = this.name.substr( lastDot + 1, this.name.length );
		this.name = this.name.substr( 0, lastDot );
	}
}

emailer.mySave = function( strFilePath ) {

	activeDocument.bitsPerChannel = BitsPerChannelType.EIGHT;

	var jpegOptions = new JPEGSaveOptions();
	jpegOptions.quality = emailer.JPEGQuality;
	jpegOptions.embedColorProfile = true;
	activeDocument.saveAs( File( strFilePath ), jpegOptions, true /* as a copy to get rid of alphas and other stuff */ );

/* was just a save
	var idsave = charIDToTypeID( "save" );
    var desc = new ActionDescriptor();
    var idIn = charIDToTypeID( "In  " );
    desc.putPath( idIn, new File( strFilePath ) );
	executeAction( idsave, desc, DialogModes.NO );
*/

}

emailer.convertTosRGBProfile = function() {
	try {
	var id136 = stringIDToTypeID( "convertToProfile" );
    var desc31 = new ActionDescriptor();
    var id137 = charIDToTypeID( "null" );
        var ref6 = new ActionReference();
        var id138 = charIDToTypeID( "Dcmn" );
        var id139 = charIDToTypeID( "Ordn" );
        var id140 = charIDToTypeID( "Trgt" );
        ref6.putEnumerated( id138, id139, id140 );
    desc31.putReference( id137, ref6 );
    var id141 = charIDToTypeID( "T   " );
    desc31.putString( id141, "sRGB IEC61966-2.1" );
    var id142 = charIDToTypeID( "Inte" );
    var id143 = charIDToTypeID( "Inte" );
    var id144 = charIDToTypeID( "Clrm" );
    desc31.putEnumerated( id142, id143, id144 );
    var id145 = charIDToTypeID( "MpBl" );
    desc31.putBoolean( id145, true );
    var id146 = charIDToTypeID( "Dthr" );
    desc31.putBoolean( id146, true );
	executeAction( id136, desc31, DialogModes.NO );
	desc31 = null;
	ref6 = null;
	$.gc();
	} catch(e) { ; }
}

///////////////////////////////////////////////////////////////////////////////
// Function: fitOnScreen
// Usage: Fit the current image on screen for best view
// Input: <nothing> an open document
// Return: <nothing> altered view
///////////////////////////////////////////////////////////////////////////////
emailer.fitOnScreen = function() {
	var idslct = charIDToTypeID( "slct" );
    var desc106 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
    var ref63 = new ActionReference();
    var idMn = charIDToTypeID( "Mn  " );
    var idMnIt = charIDToTypeID( "MnIt" );
    var idFtOn = charIDToTypeID( "FtOn" );
    ref63.putEnumerated( idMn, idMnIt, idFtOn );
    desc106.putReference( idnull, ref63 );
	executeAction( idslct, desc106, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: webSharpen
// Usage: Dr. Brown's magical web sharpen thingy. Check the global to see
// if the user canceled or something went wrong the last time we tried it
// Input: d, document to work on, 
//        showDialog, user wants the smart sharpen dialog to display
// Return: <nothing> a document with some nice sharpining
///////////////////////////////////////////////////////////////////////////////
emailer.webSharpen = function( d, showDialog ) {
	if (emailer.smartSharpenWasCanceled) 
		return;
	d.selection.selectAll();
	d.selection.copy();
	emailer.newChannel();
	d.paste();
	emailer.findEdges();
	emailer.showCurrentChannel();
	emailer.runLevels();
	emailer.setSelectionFromChannel();
	emailer.deleteCurrentChannel();
	emailer.showExtrasOff();
	emailer.smartSharpen( showDialog );
	d.selection.deselect();
}

///////////////////////////////////////////////////////////////////////////////
// Function: newChannel
// Usage: Make a new channel and give it some properties
// Input: <nothing> an active document
// Return: <nothing> a new channel on the document
///////////////////////////////////////////////////////////////////////////////
emailer.newChannel = function() {
	var idMk = charIDToTypeID( "Mk  " );
    var desc35 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
        var desc36 = new ActionDescriptor();
        var idNm = charIDToTypeID( "Nm  " );
        desc36.putString( idNm, "Edge Mask" );
        var idClrI = charIDToTypeID( "ClrI" );
        var idMskI = charIDToTypeID( "MskI" );
        var idMskA = charIDToTypeID( "MskA" );
        desc36.putEnumerated( idClrI, idMskI, idMskA );
        var idClr = charIDToTypeID( "Clr " );
            var desc37 = new ActionDescriptor();
            var idRd = charIDToTypeID( "Rd  " );
            desc37.putDouble( idRd, 255.000000 );
            var idGrn = charIDToTypeID( "Grn " );
            desc37.putDouble( idGrn, 0.000000 );
            var idBl = charIDToTypeID( "Bl  " );
            desc37.putDouble( idBl, 0.000000 );
        var idRGBC = charIDToTypeID( "RGBC" );
        desc36.putObject( idClr, idRGBC, desc37 );
        var idOpct = charIDToTypeID( "Opct" );
        desc36.putInteger( idOpct, 50 );
    var idChnl = charIDToTypeID( "Chnl" );
    desc35.putObject( idNw, idChnl, desc36 );
	executeAction( idMk, desc35, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: findEdges
// Usage: Run the find edges command
// Input: <nothing> an active document
// Return: <nothing> I found all the edges
///////////////////////////////////////////////////////////////////////////////
emailer.findEdges = function() {
	var idFndE = charIDToTypeID( "FndE" );
	executeAction( idFndE, undefined, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: showCurrentChannel
// Usage: Show the current channel
// Input: <nothing> an active document
// Return: <nothing> there they are
///////////////////////////////////////////////////////////////////////////////
emailer.showCurrentChannel = function() {
	var idShw = charIDToTypeID( "Shw " );
    var desc66 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var list3 = new ActionList();
            var ref40 = new ActionReference();
            var idChnl = charIDToTypeID( "Chnl" );
            var idOrdn = charIDToTypeID( "Ordn" );
            var idTrgt = charIDToTypeID( "Trgt" );
            ref40.putEnumerated( idChnl, idOrdn, idTrgt );
        list3.putReference( ref40 );
    desc66.putList( idnull, list3 );
	executeAction( idShw, desc66, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: runLevels
// Usage: Run the levels command with our parameters hard coded
// Input: <nothing> an active document
// Return: <nothing>
///////////////////////////////////////////////////////////////////////////////
emailer.runLevels = function() {
	var idLvls = charIDToTypeID( "Lvls" );
    var desc67 = new ActionDescriptor();
    var idpresetKind = stringIDToTypeID( "presetKind" );
    var idpresetKindType = stringIDToTypeID( "presetKindType" );
    var idpresetKindCustom = stringIDToTypeID( "presetKindCustom" );
    desc67.putEnumerated( idpresetKind, idpresetKindType, idpresetKindCustom );
    var idAdjs = charIDToTypeID( "Adjs" );
        var list4 = new ActionList();
            var desc68 = new ActionDescriptor();
            var idChnl = charIDToTypeID( "Chnl" );
                var ref41 = new ActionReference();
                var idChnl = charIDToTypeID( "Chnl" );
                var idOrdn = charIDToTypeID( "Ordn" );
                var idTrgt = charIDToTypeID( "Trgt" );
                ref41.putEnumerated( idChnl, idOrdn, idTrgt );
            desc68.putReference( idChnl, ref41 );
            var idInpt = charIDToTypeID( "Inpt" );
                var list5 = new ActionList();
                list5.putInteger( 0 );
                list5.putInteger( 223 );
            desc68.putList( idInpt, list5 );
            var idGmm = charIDToTypeID( "Gmm " );
            desc68.putDouble( idGmm, 2.500000 );
            var idOtpt = charIDToTypeID( "Otpt" );
                var list6 = new ActionList();
                list6.putInteger( 60 );
                list6.putInteger( 255 );
            desc68.putList( idOtpt, list6 );
        var idLvlA = charIDToTypeID( "LvlA" );
        list4.putObject( idLvlA, desc68 );
    desc67.putList( idAdjs, list4 );
	executeAction( idLvls, desc67, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: setSelectionFromChannel
// Usage: Set the selection from the current channel
// Input: <nothing> an active document
// Return: <nothing>
///////////////////////////////////////////////////////////////////////////////
emailer.setSelectionFromChannel = function() {
	var idsetd = charIDToTypeID( "setd" );
    var desc69 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref42 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref42.putProperty( idChnl, idfsel );
    desc69.putReference( idnull, ref42 );
    var idT = charIDToTypeID( "T   " );
        var ref43 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idTrgt = charIDToTypeID( "Trgt" );
        ref43.putEnumerated( idChnl, idOrdn, idTrgt );
    desc69.putReference( idT, ref43 );
	executeAction( idsetd, desc69, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: deleteCurrentChannel
// Usage: Delete the current channel
// Input: <nothing> an active document
// Return: <nothing>
///////////////////////////////////////////////////////////////////////////////
emailer.deleteCurrentChannel = function() {
	var idDlt = charIDToTypeID( "Dlt " );
    var desc72 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref46 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idTrgt = charIDToTypeID( "Trgt" );
        ref46.putEnumerated( idChnl, idOrdn, idTrgt );
    desc72.putReference( idnull, ref46 );
	executeAction( idDlt, desc72, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: smartSharpen
// Usage: Run the smart sharpen command. If user hits cancel or something goes
// wrong don't try it on next file set the global 
// emailer.smartSharpenWasCanceled and the routine that calls us will check
// Input: showDialog, user wants to see the smart sharpen dialog
//        <nothing> an active document
// Return: <nothing>
///////////////////////////////////////////////////////////////////////////////
emailer.smartSharpen = function( showDialog ) {

	try {
		var popDialog = false;
		var idsmartSharpen = stringIDToTypeID( "smartSharpen" );
		if ( showDialog && emailer.smartSharpenDesc == undefined )
			popDialog = true;
		if ( showDialog == false && emailer.smartSharpenDesc == undefined ) {
		    emailer.smartSharpenDesc = new ActionDescriptor();
		    var idAmnt = charIDToTypeID( "Amnt" );
		    var idPrc = charIDToTypeID( "#Prc" );
		    emailer.smartSharpenDesc.putUnitDouble( idAmnt, idPrc, 60.000000 );
		    var idRds = charIDToTypeID( "Rds " );
		    var idPxl = charIDToTypeID( "#Pxl" );
		    emailer.smartSharpenDesc.putUnitDouble( idRds, idPxl, 0.400000 );
		    var idThsh = charIDToTypeID( "Thsh" );
		    emailer.smartSharpenDesc.putInteger( idThsh, 0 );
		    var idAngl = charIDToTypeID( "Angl" );
		    emailer.smartSharpenDesc.putInteger( idAngl, 0 );
		    var idmoreAccurate = stringIDToTypeID( "moreAccurate" );
		    emailer.smartSharpenDesc.putBoolean( idmoreAccurate, true );
		    var idblur = charIDToTypeID( "blur" );
		    var idblurType = stringIDToTypeID( "blurType" );
		    var idlensBlur = stringIDToTypeID( "lensBlur" );
		    emailer.smartSharpenDesc.putEnumerated( idblur, idblurType, idlensBlur );
		    var idpreset = stringIDToTypeID( "preset" );
		    emailer.smartSharpenDesc.putString( idpreset, "Default" );
		    var idsdwM = charIDToTypeID( "sdwM" );
		        var desc74 = new ActionDescriptor();
		        var idAmnt = charIDToTypeID( "Amnt" );
		        var idPrc = charIDToTypeID( "#Prc" );
		        desc74.putUnitDouble( idAmnt, idPrc, 0.000000 );
		        var idWdth = charIDToTypeID( "Wdth" );
		        var idPrc = charIDToTypeID( "#Prc" );
		        desc74.putUnitDouble( idWdth, idPrc, 50.000000 );
		        var idRds = charIDToTypeID( "Rds " );
		        desc74.putInteger( idRds, 1 );
		    var idadaptCorrectTones = stringIDToTypeID( "adaptCorrectTones" );
		    emailer.smartSharpenDesc.putObject( idsdwM, idadaptCorrectTones, desc74 );
		    var idhglM = charIDToTypeID( "hglM" );
		        var desc75 = new ActionDescriptor();
		        var idAmnt = charIDToTypeID( "Amnt" );
		        var idPrc = charIDToTypeID( "#Prc" );
		        desc75.putUnitDouble( idAmnt, idPrc, 0.000000 );
		        var idWdth = charIDToTypeID( "Wdth" );
		        var idPrc = charIDToTypeID( "#Prc" );
		        desc75.putUnitDouble( idWdth, idPrc, 50.000000 );
		        var idRds = charIDToTypeID( "Rds " );
		        desc75.putInteger( idRds, 1 );
		    var idadaptCorrectTones = stringIDToTypeID( "adaptCorrectTones" );
		    emailer.smartSharpenDesc.putObject( idhglM, idadaptCorrectTones, desc75 );
		}
		emailer.smartSharpenDesc = executeAction( idsmartSharpen, emailer.smartSharpenDesc, popDialog ? DialogModes.ALL : DialogModes.NO );
	}
	catch(e) { 
		emailer.smartSharpenWasCanceled = true; 
	}
}

///////////////////////////////////////////////////////////////////////////////
// Function: stringToUnitValue
// Usage: Convert a string to a UnitValue, "6px" "6 px" et. al.
// Input: string of the number and units, could just be number and I will make
//        in pixel unites
// Return: UnitValue
///////////////////////////////////////////////////////////////////////////////
emailer.stringToUnitValue = function(inString) {
	var unitValue = "";
	var unitType = "";
	var findingNumbers = 0;
	var findingStrings = 1;
	var findingWhat = findingNumbers;
	
	for (var i = 0; i < inString.length; i++) {
		if ( ( findingWhat == findingNumbers ) && 
		     ( ( inString[i] >= "0" && inString[i] <= "9" ) ||
		     ( inString[i] == "." ) ) ) {
			unitValue += inString[i];
		} else {
			findingWhat = findingStrings;
		}
		if (findingWhat == findingStrings && inString[i] != " ") {
			unitType += inString[i];
		}
	}
	
	if (unitType.length == 0)
		unitType = "px";

	return new UnitValue(unitValue, unitType);
}

///////////////////////////////////////////////////////////////////////////////
// Function: unitsToPixels
// Usage: convert a number in the given units to pixels
// Input: value in the current units
//        units of the value to convert
//        resolution of the current value
//        value in pixels for percent conversion 
//        (How exaclty am I supposed to pass that in!)
// Return: value in pixels 
///////////////////////////////////////////////////////////////////////////////
emailer.unitsToPixels = function( value, units, resolution, docValue ) {
    var n = Number( value );
    if ( units.search( "in" ) != -1 ) {
        n = value * resolution;
        return n;
    }
    if ( units.search( "cm" ) != -1 ) {
        n = value / 2.54 * resolution;
        return n;
    }
    if ( units.search( "mm" ) != -1 ) {
        n = value / 25.4 * resolution;
        return n;
    }
    if ( units.search( "points" ) != -1 ) {
        n = value * resolution / 72.72;
        return n;
    }
    if ( units.search( "picas" ) != -1 ) {
        n = value * resolution / 72;
        return n;
    }
    if ( ( units.search( "%" ) != -1 ) && ( docValue != undefined ) ) {
        n = value * docValue / 100.0;
        return n;
    }
    return n;
}

emailer.showExtrasOff = function()
{
	var idslct = charIDToTypeID( "slct" );
    var desc13 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref10 = new ActionReference();
        var idMn = charIDToTypeID( "Mn  " );
        var idMnIt = charIDToTypeID( "MnIt" );
        var idtoggleShowExtras = stringIDToTypeID( "toggleShowExtras" );
        ref10.putEnumerated( idMn, idMnIt, idtoggleShowExtras );
    desc13.putReference( idnull, ref10 );
	executeAction( idslct, desc13, DialogModes.NO );
}

emailer.myConfirm = function(inStr) {
	var result = confirm(decodeURIComponent(unescape(inStr)));
	var s = '<object>';
	s += emailer.propertyToXML(result.toString(), "myConfirm");
	s += '</object>';
	return s;
}



// i didn't indent cuz that would be annoying
} // end overall try catch block

catch(e) {
	if (emailer.showAlerts) {
		alert( e + " : " + e.line );
	}
}

// end EMailer.jsx

